﻿Option Strict On
Option Explicit On

Imports System.IO
Imports System.Environment


Public Class Form1

    Dim BarCode As String = "\Barcode.ttf"  'Set Filename


   Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

      ExtractRessources()

      'let's test if we can use the extracted font
      Dim privateFonts As New System.Drawing.Text.PrivateFontCollection()
      privateFonts.AddFontFile(GetTempAppFolder() & BarCode)
      Dim BarcodeFont As New Font(privateFonts.Families(0), 24)
      Label1.Font = BarcodeFont

      SetDGVStyle()


      CreateRows()
   End Sub

    Private Sub CreateRows()

        Dim row As String() = {"0", "Amethyst", "24", "100", "10", "0123456", "Jim Panse GmbH",
            "Die ist eine ziemlich lange Bemerkung, die keiner braucht, aber ich mach die Bemerkung halt mal Ellenlang"}


        With DataGridView1.Rows
            For i = 0 To 30 'Let's create 31 rows
                .Add(row)
            Next
        End With

    End Sub

    Private Sub SetDGVStyle()
        ' Set the selection background color for all the cells
        DataGridView1.DefaultCellStyle.SelectionBackColor = Color.Gold
        DataGridView1.DefaultCellStyle.SelectionForeColor = Color.Black
        ' Set RowHeadersDefaultCellStyle.SelectionBackColor so that its defaul
        ' value won't override DataGridView.DefaultCellStyle.SelectionBackColor
        DataGridView1.RowHeadersDefaultCellStyle.SelectionBackColor = Color.Empty
        ' Set the background color for all rows and for alternating rows
        ' The value for alternating rows overrides the value for all rows
        DataGridView1.RowsDefaultCellStyle.BackColor = Color.LightGray
        DataGridView1.AlternatingRowsDefaultCellStyle.BackColor = Color.WhiteSmoke
        ' Set the row and column header styles
        DataGridView1.ColumnHeadersDefaultCellStyle.ForeColor = Color.White
        DataGridView1.ColumnHeadersDefaultCellStyle.BackColor = Color.Black
        DataGridView1.RowHeadersDefaultCellStyle.BackColor = Color.Black
        'SetAutoSize
        DataGridView1.AutoResizeColumnHeadersHeight()
        DataGridView1.AutoResizeRows()
      DataGridView1.AutoResizeColumns()
      Column6.DefaultCellStyle.Font = Label1.Font
      Column6.AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
    End Sub


    Dim iRow As Integer = 0
    Dim bNewPage As Boolean = True

    Private Sub PrintDocument1_PrintPage(sender As System.Object, e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim myHeaderFont As New Font("Microsoft Sans", 11, FontStyle.Bold) 'Headerfont

        Dim iSpecCells As Integer() = {0, 2, 4, 3, 7, 5} 'Index of Columns i'd like to print 

        With DataGridView1
            Dim sFormat As StringFormat = New StringFormat(StringFormatFlags.LineLimit)
            sFormat.LineAlignment = StringAlignment.Center 'Print in Center
            sFormat.Trimming = StringTrimming.EllipsisCharacter 'Shorten 
            sFormat.Alignment = StringAlignment.Center 'Print in Center

            'Dim HeaderFont As New Font("Microsoft Sans", 11, FontStyle.Bold) 'Print header Bold

            Dim y As Single = e.MarginBounds.Top '"Highest" position of PrintPage
            Do While iRow < .RowCount 'While Rows are smaller than Rowcount
                Dim row As DataGridViewRow = .Rows(iRow) 'Get the whole Row
                Dim x As Single = e.MarginBounds.Left 'Left position of PrintPage
                Dim h As Single = 0 'Needed to calculate the height

                For Each cell As Integer In iSpecCells 'For every cell i want ...
                    Dim rc As RectangleF = New RectangleF(x, y, row.Cells(cell).Size.Width, row.Cells(cell).Size.Height) 'create a rectangle
                    e.Graphics.DrawRectangle(Pens.Black, rc.Left, rc.Top, rc.Width, rc.Height) 'Draw the rectangle to fill it..

                    'with..
                    If (bNewPage) Then 'If it's a new page then set the Headertext (Columns)
                        e.Graphics.DrawString(DataGridView1.Columns(cell).HeaderText, myHeaderFont, Brushes.Black, rc, sFormat)
                    Else 'Draw the cells of the rows
                        e.Graphics.DrawString(DataGridView1.Rows(row.Cells(cell).RowIndex).Cells(cell).FormattedValue.ToString(), .Font, Brushes.Black, rc, sFormat)
                    End If

                    x += rc.Width 'x length/witdth of the rectangle
                    h = Math.Max(h, rc.Height) 'calc height of rectangle
                Next

                bNewPage = False 'Set to false so we can print a new header

                y += h 'set the height
                iRow += 1 ' row + 1

                If y + h > e.MarginBounds.Bottom Then 'If bottom is reached
                    e.HasMorePages = True 'Page got more than ...  pages
                    iRow -= 1 ' row -1 
                    bNewPage = True 'Set to true - so header will be printed again
                    Exit Sub
                End If
            Loop
            iRow = 0 ' Set to 0 when done 
        End With
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        PrintPreviewDialog1.Document = PrintDocument1
        PrintDocument1.DefaultPageSettings.Landscape = True 'Landscape True/False
        PrintPreviewDialog1.ShowDialog()
    End Sub

    ''' <summary>
    ''' Function to receive a string of the current Tempfolder
    ''' </summary>
    ''' <returns>Returns a String of the current Temp Folder of "DGV Printer"</returns>
    Private Function GetTempAppFolder() As String
        Return GetFolderPath(SpecialFolder.LocalApplicationData) & "\Temp\DGV Printer"
    End Function

    Public Sub ExtractRessources()
        If Not Directory.Exists(GetTempAppFolder) Then 'If Directory doesn't exist then..
            Directory.CreateDirectory(GetTempAppFolder()) 'Create it
            If Not File.Exists(GetTempAppFolder() & BarCode) Then 'If File doesn't exist then..
                File.WriteAllBytes(GetTempAppFolder() & BarCode, My.Resources._0815Barcode) 'create it
            End If
        End If
    End Sub

   Private counter As Integer
   Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
      Label1.Text = counter.ToString
      counter += 1
   End Sub
End Class
